<?php

class FlyerTech_Transactionale_WebhookController extends Mage_Core_Controller_Front_Action
{
    public function indexAction()
    {
        try {

            $enabled = Mage::getStoreConfig('transactionale/general/enable_leads', Mage::app()->getStore());

            if (!$enabled) {
                throw new Exception("Webhook is disabled");
            }

            $auth = Mage::app()->getRequest()->getParam('auth', '');

            if (empty($auth)) {
                throw new Exception("Empty AUTH token from GET");
            }

            $apiKey = Mage::getStoreConfig('transactionale/general/api_key', Mage::app()->getStore());

            if (empty($apiKey)) {
                throw new Exception("Empty config API_KEY");
            }

            if ($auth !== $apiKey) {
                http_response_code(401);
                throw new Exception("Invalid AUTH token");
            }

            if ($this->getRequest()->isPost()) {

                $ad_id	= $this->getRequest()->getPost('ad_id'); // l’id della campagna
                $email	= $this->getRequest()->getPost('email'); // indirizzo email
                $first_name	= $this->getRequest()->getPost('first_name'); // nome dell’utente
                $last_name	= $this->getRequest()->getPost('last_name'); // cognome
                $gender	= $this->getRequest()->getPost('gender'); // sesso (“M” o “F”)
                $phone	= $this->getRequest()->getPost('phone'); // telefono
                $coupon_code	= $this->getRequest()->getPost('coupon_code'); // il codice coupon ricevuto dall’utente, facoltativo, utile in caso di campagne multi-coupon
                $zip_code	= $this->getRequest()->getPost('zip_code'); // cap dell’utente

                if (!empty($email)) {

                    if (!empty(Mage::getModel('newsletter/subscriber')->loadByEmail($email)->getEmail())) {
                        http_response_code(400);
                        throw new Exception("User already subscribed to newsletter: {$email}");
                    }

                    Mage::getModel('newsletter/subscriber')->subscribe($email);

                    Mage::log("Lead user imported into newsletter = {$email}");
                }
            }

        } catch (Exception $e) {
            Mage::log($e->getMessage());
        }

        exit();
    }
}